Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/specialfunctions.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/specialfunctions.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/specialfunctions.cs	(revision 7294)
@@ -1594,4 +2047,81 @@
 
         double result = psif.psi(x);
+        return result;
+    }
+
+}
+public partial class alglib
+{
+
+
+    /*************************************************************************
+    Student's t distribution
+
+    Computes the integral from minus infinity to t of the Student
+    t distribution with integer k > 0 degrees of freedom:
+
+                                         t
+                                         -
+                                        | |
+                 -                      |         2   -(k+1)/2
+                | ( (k+1)/2 )           |  (     x   )
+          ----------------------        |  ( 1 + --- )        dx
+                        -               |  (      k  )
+          sqrt( k pi ) | ( k/2 )        |
+                                      | |
+                                       -
+                                      -inf.
+
+    Relation to incomplete beta integral:
+
+           1 - stdtr(k,t) = 0.5 * incbet( k/2, 1/2, z )
+    where
+           z = k/(k + t**2).
+
+    For t < -2, this is the method of computation.  For higher t,
+    a direct method is derived from integration by parts.
+    Since the function is symmetric about t=0, the area under the
+    right tail of the density is found by calling the function
+    with -t instead of t.
+
+    ACCURACY:
+
+    Tested at random 1 <= k <= 25.  The "domain" refers to t.
+                         Relative error:
+    arithmetic   domain     # trials      peak         rms
+       IEEE     -100,-2      50000       5.9e-15     1.4e-15
+       IEEE     -2,100      500000       2.7e-15     4.9e-17
+
+    Cephes Math Library Release 2.8:  June, 2000
+    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
+    *************************************************************************/
+    public static double studenttdistribution(int k, double t)
+    {
+
+        double result = studenttdistr.studenttdistribution(k, t);
+        return result;
+    }
+
+    /*************************************************************************
+    Functional inverse of Student's t distribution
+
+    Given probability p, finds the argument t such that stdtr(k,t)
+    is equal to p.
+
+    ACCURACY:
+
+    Tested at random 1 <= k <= 100.  The "domain" refers to p:
+                         Relative error:
+    arithmetic   domain     # trials      peak         rms
+       IEEE    .001,.999     25000       5.7e-15     8.0e-16
+       IEEE    10^-6,.001    25000       2.0e-12     2.9e-14
+
+    Cephes Math Library Release 2.8:  June, 2000
+    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
+    *************************************************************************/
+    public static double invstudenttdistribution(int k, double p)
+    {
+
+        double result = studenttdistr.invstudenttdistribution(k, p);
         return result;
     }
@@ -1695,534 +2225,4 @@
         trigintegrals.hyperbolicsinecosineintegrals(x, ref shi, ref chi);
         return;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Binomial distribution
-
-    Returns the sum of the terms 0 through k of the Binomial
-    probability density:
-
-      k
-      --  ( n )   j      n-j
-      >   (   )  p  (1-p)
-      --  ( j )
-     j=0
-
-    The terms are not summed directly; instead the incomplete
-    beta integral is employed, according to the formula
-
-    y = bdtr( k, n, p ) = incbet( n-k, k+1, 1-p ).
-
-    The arguments must be positive, with p ranging from 0 to 1.
-
-    ACCURACY:
-
-    Tested at random points (a,b,p), with p between 0 and 1.
-
-                  a,b                     Relative error:
-    arithmetic  domain     # trials      peak         rms
-     For p between 0.001 and 1:
-       IEEE     0,100       100000      4.3e-15     2.6e-16
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double binomialdistribution(int k, int n, double p)
-    {
-
-        double result = binomialdistr.binomialdistribution(k, n, p);
-        return result;
-    }
-
-    /*************************************************************************
-    Complemented binomial distribution
-
-    Returns the sum of the terms k+1 through n of the Binomial
-    probability density:
-
-      n
-      --  ( n )   j      n-j
-      >   (   )  p  (1-p)
-      --  ( j )
-     j=k+1
-
-    The terms are not summed directly; instead the incomplete
-    beta integral is employed, according to the formula
-
-    y = bdtrc( k, n, p ) = incbet( k+1, n-k, p ).
-
-    The arguments must be positive, with p ranging from 0 to 1.
-
-    ACCURACY:
-
-    Tested at random points (a,b,p).
-
-                  a,b                     Relative error:
-    arithmetic  domain     # trials      peak         rms
-     For p between 0.001 and 1:
-       IEEE     0,100       100000      6.7e-15     8.2e-16
-     For p between 0 and .001:
-       IEEE     0,100       100000      1.5e-13     2.7e-15
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double binomialcdistribution(int k, int n, double p)
-    {
-
-        double result = binomialdistr.binomialcdistribution(k, n, p);
-        return result;
-    }
-
-    /*************************************************************************
-    Inverse binomial distribution
-
-    Finds the event probability p such that the sum of the
-    terms 0 through k of the Binomial probability density
-    is equal to the given cumulative probability y.
-
-    This is accomplished using the inverse beta integral
-    function and the relation
-
-    1 - p = incbi( n-k, k+1, y ).
-
-    ACCURACY:
-
-    Tested at random points (a,b,p).
-
-                  a,b                     Relative error:
-    arithmetic  domain     # trials      peak         rms
-     For p between 0.001 and 1:
-       IEEE     0,100       100000      2.3e-14     6.4e-16
-       IEEE     0,10000     100000      6.6e-12     1.2e-13
-     For p between 10^-6 and 0.001:
-       IEEE     0,100       100000      2.0e-12     1.3e-14
-       IEEE     0,10000     100000      1.5e-12     3.2e-14
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double invbinomialdistribution(int k, int n, double y)
-    {
-
-        double result = binomialdistr.invbinomialdistribution(k, n, y);
-        return result;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Chi-square distribution
-
-    Returns the area under the left hand tail (from 0 to x)
-    of the Chi square probability density function with
-    v degrees of freedom.
-
-
-                                      x
-                                       -
-                           1          | |  v/2-1  -t/2
-     P( x | v )   =   -----------     |   t      e     dt
-                       v/2  -       | |
-                      2    | (v/2)   -
-                                      0
-
-    where x is the Chi-square variable.
-
-    The incomplete gamma integral is used, according to the
-    formula
-
-    y = chdtr( v, x ) = igam( v/2.0, x/2.0 ).
-
-    The arguments must both be positive.
-
-    ACCURACY:
-
-    See incomplete gamma function
-
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double chisquaredistribution(double v, double x)
-    {
-
-        double result = chisquaredistr.chisquaredistribution(v, x);
-        return result;
-    }
-
-    /*************************************************************************
-    Complemented Chi-square distribution
-
-    Returns the area under the right hand tail (from x to
-    infinity) of the Chi square probability density function
-    with v degrees of freedom:
-
-                                     inf.
-                                       -
-                           1          | |  v/2-1  -t/2
-     P( x | v )   =   -----------     |   t      e     dt
-                       v/2  -       | |
-                      2    | (v/2)   -
-                                      x
-
-    where x is the Chi-square variable.
-
-    The incomplete gamma integral is used, according to the
-    formula
-
-    y = chdtr( v, x ) = igamc( v/2.0, x/2.0 ).
-
-    The arguments must both be positive.
-
-    ACCURACY:
-
-    See incomplete gamma function
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double chisquarecdistribution(double v, double x)
-    {
-
-        double result = chisquaredistr.chisquarecdistribution(v, x);
-        return result;
-    }
-
-    /*************************************************************************
-    Inverse of complemented Chi-square distribution
-
-    Finds the Chi-square argument x such that the integral
-    from x to infinity of the Chi-square density is equal
-    to the given cumulative probability y.
-
-    This is accomplished using the inverse gamma integral
-    function and the relation
-
-       x/2 = igami( df/2, y );
-
-    ACCURACY:
-
-    See inverse incomplete gamma function
-
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double invchisquaredistribution(double v, double y)
-    {
-
-        double result = chisquaredistr.invchisquaredistribution(v, y);
-        return result;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    F distribution
-
-    Returns the area from zero to x under the F density
-    function (also known as Snedcor's density or the
-    variance ratio density).  This is the density
-    of x = (u1/df1)/(u2/df2), where u1 and u2 are random
-    variables having Chi square distributions with df1
-    and df2 degrees of freedom, respectively.
-    The incomplete beta integral is used, according to the
-    formula
-
-    P(x) = incbet( df1/2, df2/2, (df1*x/(df2 + df1*x) ).
-
-
-    The arguments a and b are greater than zero, and x is
-    nonnegative.
-
-    ACCURACY:
-
-    Tested at random points (a,b,x).
-
-                   x     a,b                     Relative error:
-    arithmetic  domain  domain     # trials      peak         rms
-       IEEE      0,1    0,100       100000      9.8e-15     1.7e-15
-       IEEE      1,5    0,100       100000      6.5e-15     3.5e-16
-       IEEE      0,1    1,10000     100000      2.2e-11     3.3e-12
-       IEEE      1,5    1,10000     100000      1.1e-11     1.7e-13
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double fdistribution(int a, int b, double x)
-    {
-
-        double result = fdistr.fdistribution(a, b, x);
-        return result;
-    }
-
-    /*************************************************************************
-    Complemented F distribution
-
-    Returns the area from x to infinity under the F density
-    function (also known as Snedcor's density or the
-    variance ratio density).
-
-
-                         inf.
-                          -
-                 1       | |  a-1      b-1
-    1-P(x)  =  ------    |   t    (1-t)    dt
-               B(a,b)  | |
-                        -
-                         x
-
-
-    The incomplete beta integral is used, according to the
-    formula
-
-    P(x) = incbet( df2/2, df1/2, (df2/(df2 + df1*x) ).
-
-
-    ACCURACY:
-
-    Tested at random points (a,b,x) in the indicated intervals.
-                   x     a,b                     Relative error:
-    arithmetic  domain  domain     # trials      peak         rms
-       IEEE      0,1    1,100       100000      3.7e-14     5.9e-16
-       IEEE      1,5    1,100       100000      8.0e-15     1.6e-15
-       IEEE      0,1    1,10000     100000      1.8e-11     3.5e-13
-       IEEE      1,5    1,10000     100000      2.0e-11     3.0e-12
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double fcdistribution(int a, int b, double x)
-    {
-
-        double result = fdistr.fcdistribution(a, b, x);
-        return result;
-    }
-
-    /*************************************************************************
-    Inverse of complemented F distribution
-
-    Finds the F density argument x such that the integral
-    from x to infinity of the F density is equal to the
-    given probability p.
-
-    This is accomplished using the inverse beta integral
-    function and the relations
-
-         z = incbi( df2/2, df1/2, p )
-         x = df2 (1-z) / (df1 z).
-
-    Note: the following relations hold for the inverse of
-    the uncomplemented F distribution:
-
-         z = incbi( df1/2, df2/2, p )
-         x = df2 z / (df1 (1-z)).
-
-    ACCURACY:
-
-    Tested at random points (a,b,p).
-
-                 a,b                     Relative error:
-    arithmetic  domain     # trials      peak         rms
-     For p between .001 and 1:
-       IEEE     1,100       100000      8.3e-15     4.7e-16
-       IEEE     1,10000     100000      2.1e-11     1.4e-13
-     For p between 10^-6 and 10^-3:
-       IEEE     1,100        50000      1.3e-12     8.4e-15
-       IEEE     1,10000      50000      3.0e-12     4.8e-14
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double invfdistribution(int a, int b, double y)
-    {
-
-        double result = fdistr.invfdistribution(a, b, y);
-        return result;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Poisson distribution
-
-    Returns the sum of the first k+1 terms of the Poisson
-    distribution:
-
-      k         j
-      --   -m  m
-      >   e    --
-      --       j!
-     j=0
-
-    The terms are not summed directly; instead the incomplete
-    gamma integral is employed, according to the relation
-
-    y = pdtr( k, m ) = igamc( k+1, m ).
-
-    The arguments must both be positive.
-    ACCURACY:
-
-    See incomplete gamma function
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double poissondistribution(int k, double m)
-    {
-
-        double result = poissondistr.poissondistribution(k, m);
-        return result;
-    }
-
-    /*************************************************************************
-    Complemented Poisson distribution
-
-    Returns the sum of the terms k+1 to infinity of the Poisson
-    distribution:
-
-     inf.       j
-      --   -m  m
-      >   e    --
-      --       j!
-     j=k+1
-
-    The terms are not summed directly; instead the incomplete
-    gamma integral is employed, according to the formula
-
-    y = pdtrc( k, m ) = igam( k+1, m ).
-
-    The arguments must both be positive.
-
-    ACCURACY:
-
-    See incomplete gamma function
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double poissoncdistribution(int k, double m)
-    {
-
-        double result = poissondistr.poissoncdistribution(k, m);
-        return result;
-    }
-
-    /*************************************************************************
-    Inverse Poisson distribution
-
-    Finds the Poisson variable x such that the integral
-    from 0 to x of the Poisson density is equal to the
-    given probability y.
-
-    This is accomplished using the inverse gamma integral
-    function and the relation
-
-       m = igami( k+1, y ).
-
-    ACCURACY:
-
-    See inverse incomplete gamma function
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double invpoissondistribution(int k, double y)
-    {
-
-        double result = poissondistr.invpoissondistribution(k, y);
-        return result;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Student's t distribution
-
-    Computes the integral from minus infinity to t of the Student
-    t distribution with integer k > 0 degrees of freedom:
-
-                                         t
-                                         -
-                                        | |
-                 -                      |         2   -(k+1)/2
-                | ( (k+1)/2 )           |  (     x   )
-          ----------------------        |  ( 1 + --- )        dx
-                        -               |  (      k  )
-          sqrt( k pi ) | ( k/2 )        |
-                                      | |
-                                       -
-                                      -inf.
-
-    Relation to incomplete beta integral:
-
-           1 - stdtr(k,t) = 0.5 * incbet( k/2, 1/2, z )
-    where
-           z = k/(k + t**2).
-
-    For t < -2, this is the method of computation.  For higher t,
-    a direct method is derived from integration by parts.
-    Since the function is symmetric about t=0, the area under the
-    right tail of the density is found by calling the function
-    with -t instead of t.
-
-    ACCURACY:
-
-    Tested at random 1 <= k <= 25.  The "domain" refers to t.
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE     -100,-2      50000       5.9e-15     1.4e-15
-       IEEE     -2,100      500000       2.7e-15     4.9e-17
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double studenttdistribution(int k, double t)
-    {
-
-        double result = studenttdistr.studenttdistribution(k, t);
-        return result;
-    }
-
-    /*************************************************************************
-    Functional inverse of Student's t distribution
-
-    Given probability p, finds the argument t such that stdtr(k,t)
-    is equal to p.
-
-    ACCURACY:
-
-    Tested at random 1 <= k <= 100.  The "domain" refers to p:
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE    .001,.999     25000       5.7e-15     8.0e-16
-       IEEE    10^-6,.001    25000       2.0e-12     2.9e-14
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1995, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double invstudenttdistribution(int k, double p)
-    {
-
-        double result = studenttdistr.invstudenttdistribution(k, p);
-        return result;
     }
 
